package minicollection;

import java.util.Iterator;

public abstract class AbstractMiniBagPairsBridge<K,V> 
		extends AbstractMiniBagPairs<K,V> {

	//implementation
	protected IMiniBagPairsImplementation<K,V> impl;
	
	//constructor
	AbstractMiniBagPairsBridge(IMiniBagPairsImplementation<K,V> impl,
						MembershipMode membershipMode) {
		super(membershipMode);  
		this.impl = impl;
	}

	
	public int size() {
		
		return impl.implSize();
	}
	
	public boolean contains(Object key) {
		return impl.implContains(key);
	}

	public int count(Object key) {
		return impl.implCount(key);
	}

	public boolean isEmpty() {
		return impl.implIsEmpty();
	}
	
	public void removeDuplicates() {
		impl.implRemoveDuplicates();
	}

	public boolean clear() {
		return impl.implClear();
	}


	public Iterator<IMiniKeyValuePair<IMiniKeyValuePair<K, V>, Integer>> iterator() {
		return impl.implIterator();
	}

	public IMiniIterator<IMiniKeyValuePair<IMiniKeyValuePair<K, V>, Integer>> miniIterator() {
		return impl.implMiniIterator();
	}

	public InsertCheck add(K key, V value) {
		return impl.implAdd(key, value);
	
	}
		
	public boolean removeAll(K key) {
		return impl.implRemove(key);	}
	
	
	public IMiniBagPairsIterator<K, V> bagIterator() {
		return impl.implBagIterator();	}


	public boolean containsPair(K key, V value) {
		return impl.implContainsPair(key, value); }


	public int countPair(K key, V value) {
		return impl.implCountPair(key, value); }


	public boolean removeOnePair(K key, V value) {
		return impl.implRemoveOnePair(key, value); }

	public boolean removeAllPair(K key, V value) {
		return impl.implRemoveAllPair(key, value); }

	public int uniqueKeySize() {
		return impl.implUniqueKeySize(); }


	public int uniqueKeyValuePairSize() {
		return impl.implUniqueKeyValuePairSize();
	}

	public IMiniSequence<K> getKeys() {return impl.implGetKeys(); }
	
	public IMiniSequence<IMiniKeyValuePair<V,Integer>> getValuesAndCounts(K key) {
		return impl.implGetValuesAndCounts(key);
	}

	public IMiniSequence<V> getValues(K key) {
		return impl.implGetValues(key);
	}
	
	public IMiniSequence<IMiniKeyValuePair<IMiniKeyValuePair<K, V>, Integer>>
							getKeyValuePairsAndCounts() {
		return impl.implGetKeyValuePairsAndCounts();
	}
		
	// probably want to change to a set when I actually have one
	public IMiniSequence<IMiniKeyValuePair<K,V>> getKeyValuePairs() {
		return impl.implGetKeyValuePairs();
	}
	
	public void removeDuplicateKeys() {impl.implRemoveDuplicateKeys(); }


}
