package minicollection;

import java.util.Iterator;

public abstract class AbstractMiniBagPairsDecorator<K,V> 
									extends AbstractMiniBagPairs<K,V> {

	protected IMiniBagPairs<K,V> inner;
	
	AbstractMiniBagPairsDecorator(IMiniBagPairs<K,V> inner, 
			MembershipMode membershipMode)
	{
		super(membershipMode);
		this.inner = inner;
	}
	
	
	public boolean contains(Object element) {
		return inner.contains(element);
	}

	public int count(Object element) {
		return inner.count(element);
	}
	
	public int size() {
		return inner.size();
	}

	public boolean isEmpty() {
		return inner.isEmpty();
	}
	

	public boolean clear() {
		return inner.clear();
	}
	
	public void removeDuplicates() {
		inner.removeDuplicates();
	}

	public Iterator<IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>> iterator() {
		return inner.iterator();
	}

	public IMiniIterator<IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>> miniIterator() {
		return inner.miniIterator();
	}

	public InsertCheck add(K key, V value) {
		return inner.add(key, value);
	
	}
		
	public boolean removeAll(K key) {
		return inner.removeAll(key);	}
	
	
	public IMiniBagPairsIterator<K, V> bagIterator() {
		return inner.bagIterator();	}


	public boolean containsPair(K key, V value) {
		return inner.containsPair(key, value); }


	public int countPair(K key, V value) {
		return inner.countPair(key, value); }


	public boolean removeOnePair(K key, V value) {
		return inner.removeOnePair(key, value); }

	public boolean removeAllPair(K key, V value) {
		return inner.removeAllPair(key, value); }

	public int uniqueKeySize() {
		return inner.uniqueKeySize(); }


	public int uniqueKeyValuePairSize() {
		return inner.uniqueKeyValuePairSize();
	}

	public IMiniSequence<K> getKeys() {return inner.getKeys(); }
	
	public IMiniSequence<IMiniKeyValuePair<V,Integer>> getValuesAndCounts(K key) {
		return inner.getValuesAndCounts(key);
	}
	

	public IMiniSequence<V> getValues(K key) {
		return inner.getValues(key);
	}
	
	public IMiniSequence<IMiniKeyValuePair<IMiniKeyValuePair<K, V>, Integer>>
							getKeyValuePairsAndCounts() {
		return inner.getKeyValuePairsAndCounts();
	}
		
	// probably want to change to a set when I actually have one
	public IMiniSequence<IMiniKeyValuePair<K,V>> getKeyValuePairs() {
		return inner.getKeyValuePairs();
	}

	public void removeDuplicateKeys() { inner.removeDuplicateKeys(); }

}
