package minicollection;

import java.util.Iterator;

public abstract class AbstractMiniBagSinglesBridge<K> 
			extends AbstractMiniBagSingles<K> {
	
	//implementation
	protected IMiniBagSinglesImplementation<K> impl;
	
	//constructor
	AbstractMiniBagSinglesBridge(IMiniBagSinglesImplementation<K> impl,
			MembershipMode membershipMode) {
		super(membershipMode);
		this.impl = impl;
	}
	
		
	public int size() {
		return impl.implSize();
	}
	
	public int uniqueKeySize() {
		return impl.implUniqueKeySize();
	}

	public boolean contains(Object key) {
		return impl.implContains(key);
	}

	public int count(Object key) {
		return impl.implCount(key);
	}

	public boolean isEmpty() {
		return impl.implIsEmpty();
	}
	
	public void removeDuplicates() {
		impl.implRemoveDuplicates();
	}

	public boolean clear() {
		return impl.implClear();
	}


	public Iterator<IMiniKeyValuePair<K,Integer>> iterator() {
		return impl.implIterator();
	}


	public IMiniIterator<IMiniKeyValuePair<K,Integer>> miniIterator() {
		return impl.implMiniIterator();
	}

	public InsertCheck add(K key) {
		return impl.implAdd(key);
	}

	
	public boolean removeOne(K key) {
		return impl.implRemoveOne(key);
	}
	
	public boolean removeAll(K key) {
		return impl.implRemoveAll(key);
	}
	
	public IMiniSequence<K> getKeys() {return impl.implGetKeys(); }
	
	public IMiniSequence<IMiniKeyValuePair<K, Integer>> 
			getKeysAndCounts() { return impl.implGetKeysAndCounts();
	}
	
	public IMiniBagSinglesIterator<K> bagIterator() 
		{return impl.implBagIterator(); }

}
    