package minicollection;

import java.util.Iterator;

public abstract class AbstractMiniBagSinglesDecorator<K> 
									extends AbstractMiniBagSingles<K> {

	protected IMiniBagSingles<K> inner;
	
	AbstractMiniBagSinglesDecorator(IMiniBagSingles<K> inner, 
			MembershipMode membershipMode)
	{
		super(membershipMode);
		this.inner = inner;
	}
	
	
	public boolean contains(Object element) {
		return inner.contains(element);
	}

	public int count(Object element) {
		return inner.count(element);
	}
	
	public int size() {
		return inner.size();
	}

	public boolean isEmpty() {
		return inner.isEmpty();
	}
	

	public boolean clear() {
		return inner.clear();
	}
	
	public void removeDuplicates() {
		inner.removeDuplicates();
	}

	public Iterator<IMiniKeyValuePair<K,Integer>> iterator() {
		return inner.iterator();
	}

	public IMiniIterator<IMiniKeyValuePair<K,Integer>> miniIterator() {
		return inner.miniIterator();
	}

	public InsertCheck add(K element) {
		return inner.add(element);
	}

	public boolean removeOne(K element) {
		return inner.removeOne(element);
	}
	
	public boolean removeAll(K element) {
		return inner.removeAll(element);
	}

	
	public int uniqueKeySize() {
		// number of keys
		return inner.uniqueKeySize();
	}
	
	public IMiniSequence<K> getKeys() {return inner.getKeys(); }
		
	public IMiniSequence<IMiniKeyValuePair<K, Integer>> getKeysAndCounts() {
		return inner.getKeysAndCounts();
	}
	
	public IMiniBagSinglesIterator<K> bagIterator() 
		{return inner.bagIterator(); }


}
