package minicollection;

import java.util.Comparator;


public abstract class AbstractMiniSequence<E>
					extends AbstractMiniCollection<E>
					implements IMiniSequence<E> {
	
	private OrderingMode orderingMode;
		
	AbstractMiniSequence(MembershipMode membershipMode,
			OrderingMode orderingMode) {
		super(membershipMode);
		this.orderingMode= orderingMode;
	}
	
	public OrderingMode getOrderingMode() { return orderingMode; }
	
	//TODO
	public boolean equals(Object o) {return ((Object)this).equals(o);}
	
	//TODO
	public int hashCode() { return ((Object)this).hashCode(); }

	public final E getAtIndex(int index) {
		indexCheck(index);
		return primitive_getAtIndex(index);
	}

	public final int nextIndexOf(int index, Object o) {
		indexCheck(index);
		return primitive_nextIndexOf(index, o);
	}

	
	

	
	public final void sort() {
		primitive_sort();
		orderingMode = OrderingMode.NATURAL_ORDERING;
	}
	
	public final void sort(Comparator<? super E> c) {
		primitive_sort(c);
		orderingMode = OrderingMode.CUSTOM_ORDERING;
	}

	
	public final IMiniSequenceIterator<E> seqIterator(int index) {
		indexCheck(index);
		return primitive_seqIterator(index);
	}
	
	public final void resetAccessMode(AccessMode accessMode) {
		if (this.getAccessMode() != accessMode) {
			primitive_resetAccessMode(accessMode);
		}
	}

	
	protected void indexCheck(int index) {
		if (index >= size())
			throw new IndexOutOfBoundsException("index >= size()");
		if (index < 0)
			throw new IndexOutOfBoundsException("index < 0");
	}
	
	
	
	
	
	protected abstract E primitive_getAtIndex(int index);

	protected abstract int primitive_nextIndexOf(int index, Object o);

	protected abstract IMiniSequenceIterator<E> 
		primitive_seqIterator(int index);
	
	protected final void setOrderingMode(OrderingMode orderMode) {
		this.orderingMode = orderMode;
	}
	
	protected abstract void primitive_sort();
	
	protected abstract void primitive_sort(Comparator<? super E> c);
	
	protected abstract void primitive_resetAccessMode(AccessMode accessMode);
	
	    
}      
    

	

