package minicollection;

import java.util.Comparator;
import java.util.Iterator;

public abstract class AbstractMiniSequenceDecorator<E> 
			extends AbstractMiniSequence<E> {
	
	protected IMiniSequence<E> inner;
	
	AbstractMiniSequenceDecorator(IMiniSequence<E> inner, 
			MembershipMode membershipMode, OrderingMode orderingMode)
	{
		super(membershipMode,orderingMode);
		
		this.inner = inner;
	}
	
	public AccessMode getAccessMode() {
		return inner.getAccessMode();
	}
	
	public boolean contains(Object element) {
		return inner.contains(element);
	}

	public int count(Object element) {
		return inner.count(element);
	}
	
	public int size() {
		return inner.size();
	}

	public boolean isEmpty() {
		return inner.isEmpty();
	}

	public InsertCheck add(E element) {
		return inner.add(element);
	}

	public boolean removeAll(E element) {
		return inner.removeAll(element);
	}

	public boolean clear() {
		return inner.clear();
	}
	
	public void removeDuplicates() {
		inner.removeDuplicates();
	}

	public Iterator<E> iterator() {
		return inner.iterator();
	}

	public IMiniIterator<E> miniIterator() {
		return inner.miniIterator();
	}
	
	protected void primitive_sort() {inner.sort(); }
	
	protected void primitive_sort(Comparator<? super E> c) {inner.sort(c); }
	
	/*
	protected InsertCheck primitive_addAtIndex(int index, E element) {
		return inner.addAtIndex(index, element); }
	*/

	public IMiniSequenceIterator<E> begin() {
		return inner.begin(); 
	}

	public IMiniSequenceIterator<E> end() {
		return inner.end();
	}

	public int firstIndexOf(Object o) {
		return inner.firstIndexOf(o);
	}

	protected E primitive_getAtIndex(int index) {
		return inner.getAtIndex(index);
	}

	public int lastIndexOf(Object o) {
		return inner.lastIndexOf(o);
	}

	protected int primitive_nextIndexOf(int index, Object o) {
		return inner.nextIndexOf(index, o);
	}

	/*
	protected E primitive_removeAtIndex(int index) {
		return inner.removeAtIndex(index);
	}

	
	protected boolean primitive_resetAtIndex(int index, E element) {
		return inner.resetAtIndex(index, element);
	}
	 */
	
	protected IMiniSequenceIterator<E> primitive_seqIterator(int index) {
		return inner.seqIterator(index);
	}

	protected void primitive_resetAccessMode(AccessMode accessMode) {
		inner.resetAccessMode(accessMode); }
	
}
