package minicollection;


public abstract class AbstractMiniSequenceFlexiAdd<E>
					extends AbstractMiniSequence<E>
					implements IMiniSequenceFlexiAdd<E> {
	
	AbstractMiniSequenceFlexiAdd(MembershipMode membershipMode,
			OrderingMode orderingMode) {
		super(membershipMode, orderingMode);
	}
	
	public final InsertCheck addAtIndex(int index, E element) {
		indexCheckAdd(index);
		return primitive_addAtIndex(index, element); 
	}

	public final boolean resetAtIndex(int index, E element) {
		indexCheck(index);
		return primitive_resetAtIndex(index, element);
	}
	
	public final E removeAtIndex(int index) {
		indexCheck(index);
		return primitive_removeAtIndex(index);
	}
	
	protected void indexCheckAdd(int index) {
		if (index > size())
			throw new IndexOutOfBoundsException("index > size()");
		if (index < 0)
			throw new IndexOutOfBoundsException("index < 0");
	}
	
	
	
	protected abstract InsertCheck primitive_addAtIndex(int index, E element);
	
	protected abstract boolean primitive_resetAtIndex(int index, E element);
	
	protected abstract E primitive_removeAtIndex(int index);

		    
}      
    

	

