package minicollection;

public abstract class AbstractMiniSequenceFlexiAddBridge<E> 
			extends AbstractMiniSequenceBridge<E>
			implements IMiniSequenceFlexiAdd<E> {
	
	//constructor
	AbstractMiniSequenceFlexiAddBridge(IMiniSequenceImplementation<E> impl,
						MembershipMode membershipMode, 
						OrderingMode orderingMode) {
		super(impl, membershipMode, orderingMode);
		
	}
	
	public final InsertCheck addAtIndex(int index, E element) {
		indexCheckAdd(index);
		return primitive_addAtIndex(index, element); 
	}

	public final boolean resetAtIndex(int index, E element) {
		indexCheck(index);
		return primitive_resetAtIndex(index, element);
	}
	
	public final E removeAtIndex(int index) {
		indexCheck(index);
		return primitive_removeAtIndex(index);
	}
	
	protected void indexCheckAdd(int index) {
		if (index > size())
			throw new IndexOutOfBoundsException("index > size()");
		if (index < 0)
			throw new IndexOutOfBoundsException("index < 0");
	}
	
	 
	protected boolean primitive_resetAtIndex(int index, E element) {
    	return getImpl().implResetAtIndex(index, element);
    }
    
    protected InsertCheck primitive_addAtIndex(int index, E element) {
    	return getImpl().implAddAtIndex(index, element);
    }
    
    protected E primitive_removeAtIndex(int index) { 
    	return getImpl().implRemoveAtIndex(index); }
    
    	
}
    