package minicollection;

public class FactoryJCAdaptorMiniBagPairs<K,V> implements IFactoryAdaptorMiniBagPairs<K, V> {
	
	/* (non-Javadoc)
	 * @see minicollection.IFactoryJCAdaptorMiniBagPairs#makeBagPairsAdaptor()
	 */
	public IMiniBagPairsImplementation<K,V> makeBagPairsAdaptor() {
		return new ImplJCBagPairsHashMapAdaptor<K,V>();
		
	}
	
	// does this make sense?
	/* (non-Javadoc)
	 * @see minicollection.IFactoryJCAdaptorMiniBagPairs#makeBagPairsAdaptor(minicollection.IMiniBagPairs)
	 */
	public IMiniBagPairsImplementation<K,V> makeBagPairsAdaptor(
			IMiniBagPairs<? extends K,? extends V> anotherPairsBag) {
	
		IMiniBagPairsImplementation<K,V> adaptor = 
			new ImplJCBagPairsHashMapAdaptor<K,V>();
		
		addToBag(anotherPairsBag, adaptor); // use static to capture ?
		
		return adaptor;
		
	}
	
	private static <K,V> void addToBag(IMiniBagPairs<K,V> anotherPairsBag, 
						IMiniBagPairsImplementation<? super K,? super V> adaptor) {
		for (IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer> pair 
														: anotherPairsBag) {
				
			Integer count = pair.getSecond();
			while (count > 0) {
				adaptor.implAdd(pair.getFirst().getFirst(),pair.getFirst().getSecond());
				count--;
			}
		}
	}
	
	public IMiniBagPairsImplementation<V,K> makeBagReversePairsAdaptor(
			IMiniBagPairs<? extends K,? extends V> anotherPairsBag) {
		
		IMiniBagPairsImplementation<V,K> adaptor = 
			new ImplJCBagPairsHashMapAdaptor<V,K>();
		
		addToBagReverse(anotherPairsBag, adaptor); // use static to capture ?
		
		return adaptor;
	}
	
	private static <K,V> void addToBagReverse(IMiniBagPairs<K,V> anotherPairsBag, 
			IMiniBagPairsImplementation<? super V,? super K> adaptor) {
	
		for (IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer> pair 
													: anotherPairsBag) {
			
			Integer count = pair.getSecond();
			while (count > 0) {
				V v = pair.getFirst().getSecond();
				K k = pair.getFirst().getFirst();
				adaptor.implAdd(pair.getFirst().getSecond(),pair.getFirst().getFirst());
				count--;
				int size = adaptor.implSize();
			}
		}
	}
	
}
