package minicollection;

// can't be a singleton

public class FactoryMiniBagPairs<K,V> 
	extends AbstractFactoryMiniCollection<IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>> 
	implements IFactoryMiniBagPairs<K, V> {
	
	//this should be pluggable
	private IFactoryAdaptorMiniBagPairs<K,V> adaptorFactory = null;
	
	public FactoryMiniBagPairs() {
		adaptorFactory = 
			new FactoryJCAdaptorMiniBagPairs<K,V>();
	}
	
	public FactoryMiniBagPairs(IFactoryAdaptorMiniBagPairs<K,V> adaptorFactory) {
		this.adaptorFactory = adaptorFactory;
	}
	
	public IMiniBagPairs<K,V> makeBagPairs() {
		return new MiniBagPairsBridge<K,V>(
				adaptorFactory.makeBagPairsAdaptor());
	}

	public IMiniBagPairs<K,V> makeBagPairs(
			IMiniBagPairs<? extends K, V> anotherBag) {
		return new MiniBagPairsBridge<K,V>(
				adaptorFactory.makeBagPairsAdaptor(anotherBag));
	}
	
	public IMiniBagPairs<V,K> makeBagReversePairs(
			IMiniBagPairs<? extends K, V> anotherBag) {
		return new MiniBagPairsBridge<V,K>(
				adaptorFactory.makeBagReversePairsAdaptor(anotherBag));
	}
	
	

}
