package minicollection;

// can't be a singleton

public class FactoryMiniBagPairsUniqueOnly<K,V> 
	extends AbstractFactoryMiniCollection<IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>> 
	implements IFactoryMiniBagPairs<K, V> {
	
	private IFactoryMiniBagPairs<K,V> bagFactory = 
		new FactoryMiniBagPairs<K,V>();
	
	public FactoryMiniBagPairsUniqueOnly() {};
	
	public FactoryMiniBagPairsUniqueOnly(
			IFactoryAdaptorMiniBagPairs<K,V> adaptorFactory) {
		this.bagFactory = new FactoryMiniBagPairs<K,V>(adaptorFactory);
	}
	
	public IMiniBagPairs<K,V> makeBagPairs() {
		return new MiniBagPairsUniqueKeysOnlyDecorator<K,V>(
				bagFactory.makeBagPairs());
	}

	public IMiniBagPairs<K,V> makeBagPairs(
			IMiniBagPairs<? extends K, V> anotherBag) {
		return new MiniBagPairsUniqueKeysOnlyDecorator<K,V>(
				bagFactory.makeBagPairs(anotherBag));
	}
	
	public IMiniBagPairs<V,K> makeBagReversePairs(
			IMiniBagPairs<? extends K, V> anotherBag) {
		return new MiniBagPairsUniqueKeysOnlyDecorator<V,K>(
				bagFactory.makeBagReversePairs(anotherBag));
	}
	
	

}
