package minicollection;

// can't be a singleton

public class FactoryMiniBagSingles<K> 
	extends AbstractFactoryMiniCollection<IMiniKeyValuePair<K,Integer>> 
	implements IFactoryMiniBagSingles<K> {
	
	//this should be pluggable
	private IFactoryAdaptorMiniBagSingles<K> adaptorFactory = null;
	
	public FactoryMiniBagSingles() {
		adaptorFactory = 
			new FactoryJCAdaptorMiniBagSingles<K>();
	}
	
	public FactoryMiniBagSingles(IFactoryAdaptorMiniBagSingles<K> adaptorFactory) {
		this.adaptorFactory = adaptorFactory;
	}
	
	public IMiniBagSingles<K> makeBagSingles() {
		return new MiniBagSinglesBridge<K>(
				adaptorFactory.makeBagSinglesAdaptor());
	}

	public IMiniBagSingles<K> makeBagSingles(
			IMiniBagSingles<? extends K> anotherBag) {
		return new MiniBagSinglesBridge<K>(
				adaptorFactory.makeBagSinglesAdaptor(anotherBag));
	}
	
	public IMiniBagSingles<K> makeBagSingles(
			IMiniCollection<? extends K> anotherCollection) {
		return new MiniBagSinglesBridge<K>(
				adaptorFactory.makeBagSinglesAdaptor(anotherCollection));
	}

}
