package minicollection;

// can't be a singleton

public class FactoryMiniBagSinglesUniqueOnly<K> 
	extends AbstractFactoryMiniCollection<IMiniKeyValuePair<K,Integer>> 
	implements IFactoryMiniBagSingles<K> {

	
	private IFactoryMiniBagSingles<K> bagFactory = 
		new FactoryMiniBagSingles<K>();
	
	
	public FactoryMiniBagSinglesUniqueOnly() {};
	
	public FactoryMiniBagSinglesUniqueOnly(
			IFactoryAdaptorMiniBagSingles<K> adaptorFactory) {
		this.bagFactory = new FactoryMiniBagSingles<K>(adaptorFactory);
	}
	
	
	public IMiniBagSingles<K> makeBagSingles() {
		return new MiniBagSinglesUniqueOnlyDecorator<K>(
				bagFactory.makeBagSingles());
	}

	public IMiniBagSingles<K> makeBagSingles(
			IMiniBagSingles<? extends K> anotherBag) {
		return new MiniBagSinglesUniqueOnlyDecorator<K>(
				bagFactory.makeBagSingles(anotherBag));
		
	}
	
	public IMiniBagSingles<K> makeBagSingles(
			IMiniCollection<? extends K> anotherCollection) {
		return new MiniBagSinglesUniqueOnlyDecorator<K>(
				bagFactory.makeBagSingles(anotherCollection));
	}

}
