package minicollection;

// can't be a singleton

public class FactoryMiniSequence<E> 
	extends AbstractFactoryMiniCollection<E> 
	implements IFactoryMiniSequence<E> {
	
	//this should be pluggable
	private IFactoryAdaptorMiniSequence<E> adaptorFactory = null;
	
	public FactoryMiniSequence() {
		adaptorFactory = 
			new FactoryJCAdaptorMiniSeqence<E>();
	}
	
	public FactoryMiniSequence(IFactoryAdaptorMiniSequence<E> adaptorFactory) {
		this.adaptorFactory = adaptorFactory;
	}
	
	public IMiniSequence<E> makeSequence() {
		return new MiniSequenceBridge<E>(
				adaptorFactory.makeSequenceAdaptor());
	}

	public IMiniSequence<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection) {
		return new MiniSequenceBridge<E>(
				adaptorFactory.makeSequenceAdaptor(anotherCollection));
	}

		
	public IMiniSequence<E> makeSequence(AccessMode accessMode) {
		return new MiniSequenceBridge<E>(
				adaptorFactory.makeSequenceAdaptor(accessMode));
		
	}
	
	
	public IMiniSequence<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection,
			AccessMode accessMode) {
		
		return new MiniSequenceBridge<E>(
				adaptorFactory.makeSequenceAdaptor(anotherCollection, accessMode));
		
	}

	
	public IMiniSequence<E> makeSequence(E e, int n) {

		return new MiniSequenceBridge<E>(adaptorFactory.makeSequenceAdaptor(e, n));
	}
	
	public IMiniSequence<E> makeSequence(E e, int n, AccessMode accessMode) {

		return new MiniSequenceBridge<E>(adaptorFactory.makeSequenceAdaptor(
											e, n, accessMode));
	}
	
		
}
