package minicollection;

// can't be a singleton

public class FactoryMiniSequenceFlexiAdd<E> 
	extends AbstractFactoryMiniCollection<E> 
	implements IFactoryMiniSequenceFlexiAdd<E>
{
	
	//this should be pluggable
	private IFactoryAdaptorMiniSequence<E> adaptorFactory = null;
	
	public FactoryMiniSequenceFlexiAdd() {
		adaptorFactory = 
			new FactoryJCAdaptorMiniSeqence<E>();
	}
	
	public FactoryMiniSequenceFlexiAdd(
			IFactoryAdaptorMiniSequence<E> adaptorFactory) {
		this.adaptorFactory = adaptorFactory;
	}
	
	public IMiniSequenceFlexiAdd<E> makeSequence() {
		return new MiniSequenceBridgeFlexiAdd<E>(
				adaptorFactory.makeSequenceAdaptor());
	}

	public IMiniSequenceFlexiAdd<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection) {
		return new MiniSequenceBridgeFlexiAdd<E>(
				adaptorFactory.makeSequenceAdaptor(anotherCollection));
	}

		
	public IMiniSequenceFlexiAdd<E> makeSequence(AccessMode accessMode) {
		return new MiniSequenceBridgeFlexiAdd<E>(
				adaptorFactory.makeSequenceAdaptor(accessMode));
		
	}
	
	
	public IMiniSequenceFlexiAdd<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection,
			AccessMode accessMode) {
		
		return new MiniSequenceBridgeFlexiAdd<E>(
				adaptorFactory.makeSequenceAdaptor(anotherCollection, accessMode));
		
	}

	
	public IMiniSequenceFlexiAdd<E> makeSequence(E e, int n) {

		return new MiniSequenceBridgeFlexiAdd<E>(
				adaptorFactory.makeSequenceAdaptor(e, n));
	}
	
	public IMiniSequenceFlexiAdd<E> makeSequence(E e, int n, AccessMode accessMode) {

		return new MiniSequenceBridgeFlexiAdd<E>(adaptorFactory.makeSequenceAdaptor(
											e, n, accessMode));
	}
}
