package minicollection;

import java.util.Comparator;

public class FactoryMiniSequenceNaturallySorted<E extends Comparable<? super E>> 
	extends AbstractFactoryMiniCollection<E> 
	implements IFactoryMiniSequence<E> {

	
	private static class CustomComparator<E extends Comparable<? super E>>
	implements Comparator<E>
	{
		public int compare(E e1, E e2) {
		
		return e1.compareTo(e2);
		}
	}
	
	private IFactoryMiniSequence<E> sequenceFactory = 
		new FactoryMiniSequenceCustomSorted<E>(new CustomComparator<E>());
	
	public FactoryMiniSequenceNaturallySorted() {};
	
	public FactoryMiniSequenceNaturallySorted(
			IFactoryAdaptorMiniSequence<E> adaptorFactory) {
		sequenceFactory = new FactoryMiniSequenceCustomSorted<E>(
				new CustomComparator<E>(), adaptorFactory);
	};
	
	
	public IMiniSequence<E> makeSequence() {
		return 	sequenceFactory.makeSequence();
	}
	
	public IMiniSequence<E> makeSequence(AccessMode accessMode) {
		return 	sequenceFactory.makeSequence(accessMode);
	}
	
	public IMiniSequence<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection) {
		return sequenceFactory.makeSequence(anotherCollection);
	}
	
	public IMiniSequence<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection,
			AccessMode accessMode) {
		return 	sequenceFactory.makeSequence(anotherCollection, accessMode);
	}
	
	public IMiniSequence<E> makeSequence(E e, int n) {
		return 	sequenceFactory.makeSequence(e, n);
	}
	
	public IMiniSequence<E> makeSequence(E e, int n, AccessMode accessMode) {

		return 	sequenceFactory.makeSequence(e, n, accessMode);
	}
	
	
}
