package minicollection;


public class FactoryMiniSequenceUniqueOnly<E> 
	extends AbstractFactoryMiniCollection<E> 
	implements IFactoryMiniSequenceFlexiAdd<E> {

	
	private IFactoryMiniSequenceFlexiAdd<E> sequenceFactory = 
		new FactoryMiniSequenceFlexiAdd<E>();
	
	public FactoryMiniSequenceUniqueOnly() {};
	
	public FactoryMiniSequenceUniqueOnly(
			IFactoryAdaptorMiniSequence<E> adaptorFactory) {
		sequenceFactory = new FactoryMiniSequenceFlexiAdd<E>(adaptorFactory);
	};
		
	public IMiniSequenceFlexiAdd<E> makeSequence() {
		return new MiniSequenceFlexiAddUniqueOnlyDecorator<E>(
				sequenceFactory.makeSequence());
	}
	
	public IMiniSequenceFlexiAdd<E> makeSequence(AccessMode accessMode) {
		return new MiniSequenceFlexiAddUniqueOnlyDecorator<E>(
				sequenceFactory.makeSequence(accessMode));
	}
	
	public IMiniSequenceFlexiAdd<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection) {
		return new MiniSequenceFlexiAddUniqueOnlyDecorator<E>(
				sequenceFactory.makeSequence(anotherCollection));
	}
	
	public IMiniSequenceFlexiAdd<E> makeSequence(
			IMiniCollection<? extends E> anotherCollection,
			AccessMode accessMode) {
		return new MiniSequenceFlexiAddUniqueOnlyDecorator<E>(
				sequenceFactory.makeSequence(anotherCollection, accessMode));
	}
	
	public IMiniSequenceFlexiAdd<E> makeSequence(E e, int n) {
		return new MiniSequenceFlexiAddUniqueOnlyDecorator<E>(
				sequenceFactory.makeSequence(e, n));
	}
	
	public IMiniSequenceFlexiAdd<E> makeSequence(E e, int n, AccessMode accessMode) {

		return new MiniSequenceFlexiAddUniqueOnlyDecorator<E>(
				sequenceFactory.makeSequence(e, n, accessMode));
	}
	
}
