package minicollection;



public interface IMiniBagPairs<K,V> 
		extends IMiniCollection<IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>> {

	// aka maps!
	
	InsertCheck add(K key, V value);
	
	boolean removeOnePair(K key, V value);
	
	boolean removeAllPair(K key, V value);
	
	boolean removeAll(K key);
	
	boolean containsPair(K key, V value);
	
	int countPair (K key, V value);
	
	int uniqueKeySize(); // number of unique keys
	
	int uniqueKeyValuePairSize(); // number of unique pairs
	
	IMiniSequence<K> getKeys();
	
	IMiniSequence<IMiniKeyValuePair<V,Integer>> getValuesAndCounts(K key);
	
	IMiniSequence<V> getValues(K key);
		
	IMiniSequence<IMiniKeyValuePair<IMiniKeyValuePair<K, V>, Integer>>
							getKeyValuePairsAndCounts();
		
	// probably want to change to a set when I actually have one
	IMiniSequence<IMiniKeyValuePair<K,V>> getKeyValuePairs();
	
	void removeDuplicateKeys();
	
	// Iteration
	IMiniBagPairsIterator<K,V> bagIterator(); 

}
