package minicollection;

/**
 * A collection type for elements of type E.
 * The collection may have operations which do alter the membership
 * of the collection (add elements, remove elements, or change elements through
 * an operation of the collection).
 * 
 * @author jah217
 *
 */
public interface IMiniCollection<E> extends IMiniBasicCollection<E> {
	
	/**
     * Empties the collection.
     * 
     * @pre void  
     * @post there are no elements in the collection (isEmpty() == true) 
     * 
     * @return true if the operation has been completed.
     */
    boolean clear();
    
    /**
     * Removes duplicate elements in the collection.
     * Two elements e1 and e2 are duplicates if e2.equals(e2) == true.
     *
     * @pre void  
     * @post there are no two elements e1 and e2 in the collection for 
     * which e2.equals(e2) == true. 
     * 
     */
    void removeDuplicates();
	
}
