package minicollection;

/**
 *  An ordered pair of two member objects.
 *  The first member in the pair has type E.
 *  The second member in the pair and has type T. 
 * 
 * @author jah217
 */

public interface IMiniGeneralPair<E ,T> extends IMiniPair<E,T> {
	
	/**
	 * Sets the first member of the pair to a given value.
	 * 
	 * @param value the E type object to become the first member in the pair. 
	 */
	void setFirst(E first);
	
	/**
	 * Sets the second member of the pair to a given value.
	 * 
	 * @param value the T type object to become the second member in the pair. 
	 */
	void setSecond(T second);

}
