package minicollection;

/**
 * An iterator over a collection of elements of type E. 
 * 
 * @author jah217
 *
 */
  
public interface IMiniIterator<E> {

	/**
	 * Check if iteration has more elements.
	 * 
	 * @return true if iterator has more elements, false otherwise.
	 */
	boolean hasNext();

	
	/**
	 * Point to the next element in the iteration, if any.
	 * If there is no next element in the collection, point to null.
	 */
	void next(); 

	
	/**
	 * Get the element in the collection currently pointed to by the iterator.  
	 * Returns null if there is no element E currently pointed to.
	 * 
	 * @return the element currently pointed to in the collection (null if no
	 * element E currently pointed to).
	 */
	E current();

	
}
