package minicollection;

/**
 *  An ordered (key,value) pair of two member objects.
 *  The key object is the first member in the pair and has type K.
 *  The value object is the second member in the pair and has type V. 
 * 
 * @author jah217
 */
public interface IMiniKeyValuePair<K,V> extends IMiniPair<K,V> {
	
	/**
	 * Sets the value (second) member of the pair to a given value.
	 * 
	 * @param value the V type object to become the second member in the pair. 
	 */
	void setSecond(V value);
	
}
