package minicollection;

/**
 * An ordered pair of two members objects.
 * The first object in the pair has type E. 
 * The second object in the pair has type T. 
 * 
 * @author jah217
 *
 */
  

public interface IMiniPair<E,T> {
	
	/**
	 * Test an object o for equality with this.  Should return true if and only 
	 * if the other object o is has the same class as this and 
	 * getFirst().equalTo(o.getFirst()) and getSecond().equalTo(o.getSecond())
	 * 
	 * @param o The object to test for equality with this.
	 * @return true if o has the same class as this and the same ordered members.
	 */
	boolean equals(Object o);
	
	/**
	 * Compute a hashcode computed using the hashcodes of the members and 
	 * compatible with equals().
	 * 
	 * @return a hashcode computed from the hashcodes of the member objects
	 */
	int hashCode();
	
	/**
	 * Return the first member in the ordered pair represented by this.
	 * 
	 * @return the first member of the pair
	 */
	E getFirst();
	
	/**
	 * Return the second member in the ordered pair represented by this.
	 * 
	 * @return the second members of the pair
	 */
	T getSecond();
	
	
}
