package minicollection;

import java.util.Comparator;
//import java.util.Iterator;

public interface IMiniSequenceImplementation<E> extends IMiniCollectionImplementation<E>{
	
	// Basic operations
    //int implSize();
    //boolean implIsEmpty();
    //boolean implContains(Object element);
    //int implCount(Object element); // duplicates count?
    //void implClear();
    
    // Iteration
    //INewIterator<E> newiterator(); // from extends INewIterable
    //Iterator<E> iterator(); // from extends Iterable
	
	AccessMode implGetAccessMode();
	
    InsertCheck implAdd(E element);      
    boolean implRemoveAll(E element);
    
	void implSort();
	void implSort(Comparator<? super E> c);
	
	E implGetAtIndex(int index);
    boolean implResetAtIndex(int index, E element); 
    
    InsertCheck implAddAtIndex(int index, E element); // makes no sense - see iterator add
    E implRemoveAtIndex(int index);            //optional
    
    //boolean addAll(int index, Collection<? extends E> c); //optional
    
    // Search
    int implFirstIndexOf(Object o);
    //int implNextIndexOf(Object o);
    int implNextIndexOf(int index, Object o );
    int implLastIndexOf(Object o);

    // Iteration
    IMiniSequenceIterator<E> implBegin(); // just before the beginning
    IMiniSequenceIterator<E> implEnd();  // just before final element
    IMiniSequenceIterator<E> implSeqIterator(int index);
    //INewIterator implNewiterator(); from interface
    //Iterator<E> implIterator(); // from interface
    
    // Range-view
    //List<E> subList(int from, int to);
    
    //void implResetAccessMode(AccessMode accessMode);

}
