package minicollection;

import java.util.Iterator;
import java.util.Map.*;

public class ImplJCBagPairsIteratorAdaptor<K,V> 
					extends AbstractMiniBagPairsIterator<K,V> {
	
	private Iterator<Entry<K,IMiniBagSingles<V>>> adaptee = null;
	private Entry<K,IMiniBagSingles<V>> currentEntry = null; // the current map entry
	private IMiniBagSinglesIterator<V> bagIterator = null;
	//boolean itHasNext = false;
	
	//private IMiniKeyValuePair<V,Integer> currentValuePair = null;
	
	ImplJCBagPairsIteratorAdaptor(Iterator<Entry<K,IMiniBagSingles<V>>> adaptee,
			Entry<K,IMiniBagSingles<V>> currentEntry) {
		super(new MiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>
						(new MiniKeyValuePair<K,V>(currentEntry.getKey(), 
						currentEntry.getValue().bagIterator().currentKey()),
							currentEntry.getValue().bagIterator().currentCount())); 
		this.adaptee = adaptee;
		this.currentEntry = currentEntry;
		if (currentEntry != null) 
			this.bagIterator = currentEntry.getValue().bagIterator();
		//this.itHasNext = (bagIterator.current() != null); 
		/*
		this.currentValuePair = new MiniKeyValuePair<V,Integer>
				(currentEntry.getValue().bagIterator().currentKey(),
				currentEntry.getValue().bagIterator().currentCount());
	*/
		}
	
	public boolean hasNext() {
		/*
		boolean hasNext = false;
		if (currentEntry != null) {
			hasNext = bagIterator.hasNext();
		}
		else hasNext = adaptee.hasNext();
		*/
		return (adaptee.hasNext() || bagIterator.hasNext());
	}
	
	protected IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer> primitive_next() { 
		
		IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer> ne = null;
		
		if (bagIterator.hasNext()) {
			bagIterator.next();
			ne = new MiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>
			(new MiniKeyValuePair<K,V>(currentEntry.getKey(), 
				bagIterator.currentKey()),
					bagIterator.currentCount());
		}
		else { // bag iterator has no next
			if (adaptee.hasNext()) {
				currentEntry = adaptee.next();
				bagIterator = currentEntry.getValue().bagIterator();
				ne = new MiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>
				(new MiniKeyValuePair<K,V>(currentEntry.getKey(), 
					bagIterator.currentKey()),
						bagIterator.currentCount());
			}
			else 
				currentEntry = null;
				
		}
		return ne;
    }
	
		
	
	
	public IMiniKeyValuePair<K, V> currentPair() {
		IMiniKeyValuePair<K,V> pair = null;
		if (currentEntry != null && bagIterator != null)
			pair = new MiniKeyValuePair<K,V>(currentEntry.getKey(), 
											bagIterator.currentKey());
		return pair;
	}
    
    protected void primitive_removeCurrent() { 
    	if (currentEntry.getValue().uniqueKeySize() > 1) {
    		bagIterator.removeCurrent();
    	}
        	
    	else { // only one left
    			//we have to remove the whole current entry
    			adaptee.remove();
    			currentEntry = null;
    	}
    	
    }
    
    public K currentKey() {
		K k = null;
		if (currentEntry != null) k = currentEntry.getKey();
		return k;
	}
	
	public int currentCount() {
		int count = 0;
		if (currentEntry != null && bagIterator != null) 
			count = bagIterator.currentCount();
		return count;
	}
	
	public V currentValue() {
		V v = null;
		if (currentEntry != null && bagIterator != null)
			v = bagIterator.currentKey();
		return v;
	}
}
