package minicollection;

import java.util.Iterator;
import java.util.Map.*;

public class ImplJCBagSinglesIteratorAdaptor<K> 
					extends AbstractMiniBagSinglesIterator<K> {
	
	private Iterator<Entry<K,Integer>> adaptee = null;
	Entry<K,Integer> currentEntry = null;
	
	ImplJCBagSinglesIteratorAdaptor(Iterator<Entry<K,Integer>> adaptee,
			Entry<K,Integer> currentEntry) {
		super(new MiniKeyValuePair<K,Integer>(currentEntry.getKey(), 
												currentEntry.getValue())); 
		this.adaptee = adaptee;
		this.currentEntry = currentEntry;
	}
	
	public boolean hasNext() { 
		return 	adaptee.hasNext();
	}
	
	protected IMiniKeyValuePair<K,Integer> primitive_next() { 
		IMiniKeyValuePair<K,Integer> ne= null;
		if (adaptee.hasNext()) {
			currentEntry = adaptee.next();
    		ne = new MiniKeyValuePair<K,Integer>(currentEntry.getKey(), 
					currentEntry.getValue());
    	}
		else currentEntry = null;
	   	return ne;
    }
	
	public int currentCount() {
		int count = 0;
		if (currentEntry != null) count = currentEntry.getValue();
		return count;
	}
	
	public K currentKey() {
		K k = null;
		if (currentEntry != null) k = currentEntry.getKey();
		return k;
	}
    
    protected void primitive_removeCurrent() { 
    	adaptee.remove();
    	currentEntry = null;
    }
	
}
