package minicollection;

import java.util.Iterator;

public class ImplJCIteratorForBagPairsAdaptor<K,V> 
			implements Iterator<IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>> {

	private IMiniBagPairsIterator<K,V> adaptee;
	boolean hasNext = false;
	
	public ImplJCIteratorForBagPairsAdaptor(
			IMiniBagPairsIterator<K,V> adaptee) {
		this.adaptee = adaptee;
		this.hasNext = (adaptee.current() != null); 
	}

	public boolean hasNext() {
		return hasNext;
	}
	
	public IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer> next() {
		IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer> ne = adaptee.current();
		if (adaptee.hasNext()) {
			adaptee.next();
			hasNext = true;
		}
		else hasNext = false;
		return ne;
	}
	
	public void remove() {
		throw new UnsupportedOperationException(
				"remove() is not supported by this iterator");
		
	}
	
	
	/*
	private Iterator<Entry<K,IMiniBagSingles<V>>> adaptee = null;
	private Entry<K,IMiniBagSingles<V>> currentEntry = null; // the current map entry
	private IMiniBagSinglesIterator <V> bagIterator = null;
	
	
	ImplJCIteratorForBagPairsAdaptor(
			Iterator<Entry<K,IMiniBagSingles<V>>> adaptee,
			Entry<K,IMiniBagSingles<V>> currentEntry) {
		this.adaptee = adaptee;
		this.currentEntry = currentEntry;
		bagIterator = currentEntry.getValue().bagIterator();
	}

		
	public IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>  next() {
		
		IMiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer> ne = null;
		if (bagIterator != null && bagIterator.hasNext()) {
			bagIterator.next();
			ne = new MiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>
				(new MiniKeyValuePair<K,V>(currentEntry.getKey(), 
					bagIterator.currentKey()),
						bagIterator.currentCount());
		}
		if ((bagIterator != null && !bagIterator.hasNext()) || bagIterator == null) { 
			if (adaptee.hasNext()) {
				currentEntry = adaptee.next();
				currentEntry.getValue().bagIterator();
				ne = new MiniKeyValuePair<IMiniKeyValuePair<K,V>,Integer>
				(new MiniKeyValuePair<K,V>(currentEntry.getKey(), 
					bagIterator.currentKey()),
						bagIterator.currentCount());
			}
			else {
				currentEntry = null;
				bagIterator = null;
			}
		}
		return ne;
    }
	
	public boolean hasNext() {
		boolean hasNext = false;
		if (currentEntry != null) {
			hasNext = bagIterator.hasNext();
		}
		else hasNext = adaptee.hasNext();
		return hasNext;
	}

	public void remove() {
		if (currentEntry != null && bagIterator.currentKey() != null) {
    		
    		
    		if (currentEntry.getValue().uniqueKeySize() <= 1) {
    			//we have to remove the whole current entry
    			adaptee.remove();
    			currentEntry = null;
    			bagIterator = null;
    		}
    		else {
    			bagIterator.removeCurrent();
    		}
    	}
		
	}
	*/

}
