package minicollection;

import java.util.Iterator;

public class ImplJCIteratorForBagSinglesAdaptor<K> 
			implements Iterator<IMiniKeyValuePair<K,Integer>> {

	private IMiniBagSinglesIterator<K> adaptee;
	boolean hasNext = false;
	
	public ImplJCIteratorForBagSinglesAdaptor(
			IMiniBagSinglesIterator<K> adaptee) {
		this.adaptee = adaptee;
		this.hasNext = (adaptee.current() != null); 
	}

	public boolean hasNext() {
		return hasNext;
	}
	
	public IMiniKeyValuePair<K,Integer> next() {
		IMiniKeyValuePair<K,Integer> ne = adaptee.current();
		if (adaptee.hasNext()) {
			adaptee.next();
			hasNext = true;
		}
		else hasNext = false;
		return ne;
	}
	
	public void remove() {
		throw new UnsupportedOperationException(
				"remove() is not supported by this iterator");
		
	}
		
	
}
