package minicollection;

import java.util.Iterator;

public class ImplJCIteratorForSequenceAdaptor<E> 
			implements Iterator<E> {

	private IMiniSequenceIterator<E> adaptee;
	boolean hasNext = false;
	
	public ImplJCIteratorForSequenceAdaptor(
			IMiniSequenceIterator<E> adaptee) {
		this.adaptee = adaptee;
		this.hasNext = (adaptee.current() != null); 
	}

	public boolean hasNext() {
		return hasNext;
	}
	
	public E next() {
		E ne = adaptee.current();
		if (adaptee.hasNext()) {
			adaptee.next();
			hasNext = true;
		}
		else hasNext = false;
		return ne;
	}
	
	public void remove() {
		throw new UnsupportedOperationException(
				"remove() is not supported by this iterator");
		
	}
		
	
}
