package minicollection;

public class MiniBagPairsUniqueKeysOnlyDecorator<K,V>
				extends AbstractMiniBagPairsDecorator<K,V>{

	
	public MiniBagPairsUniqueKeysOnlyDecorator(IMiniBagPairs<K,V> inner) {
		super(inner, MembershipMode.UNIQUES_ONLY);
		inner.removeDuplicateKeys();
	}
	
	
	@Override
	public InsertCheck add(K key, V value) {
		//if contains the key, overwrite
		InsertCheck isAdded = InsertCheck.FAILED;
		if (inner.contains(key)) {
			inner.removeAll(key);
			if (inner.add(key, value) == InsertCheck.NEW) 
				isAdded = InsertCheck.OVERWRITTEN;
		}
		else isAdded = inner.add(key, value);
		
		return isAdded;
	}

}
