package minicollection;

public class MiniBagSinglesUniqueOnlyDecorator<K>
				extends AbstractMiniBagSinglesDecorator<K>{

	
	public MiniBagSinglesUniqueOnlyDecorator(IMiniBagSingles<K> inner) {
		// true for custom sorted
		super(inner, MembershipMode.UNIQUES_ONLY);
		inner.removeDuplicates();
	}
	
	
	@Override
	public InsertCheck add(K element) {
		//if contains, overwrite
		InsertCheck isAdded = InsertCheck.FAILED;
		if (inner.contains(element)) {
			inner.removeOne(element);
			if (inner.add(element) == InsertCheck.NEW) 
				isAdded = InsertCheck.OVERWRITTEN;
		}
		else isAdded = inner.add(element);
		
		return isAdded;
	}

}
