package minicollection;

import java.util.Comparator;


/**
 * @author jah217
 *
 * @param <E>
 */
public class MiniSequenceCustomSortedDecorator<E> 
				extends AbstractMiniSequenceDecorator<E> {
	
	
	Comparator<? super E> comp;
	OrderingMode decoratorOrdering;
	
	public MiniSequenceCustomSortedDecorator(IMiniSequence<E> inner,
									Comparator<? super E> comp,
									OrderingMode orderingMode) {
		super(inner, inner.getMembershipMode(), orderingMode);
		this.comp = comp;
		this.decoratorOrdering = orderingMode;
		inner.sort(comp);
	}
	
	@Override
	public InsertCheck add(E element) {
		InsertCheck isAdded =  inner.add(element);
		inner.sort(comp);
		setOrderingMode(decoratorOrdering);
		return isAdded;
	}
	
	/*
	@Override
	protected InsertCheck primitive_addAtIndex(int index, E element) {
		InsertCheck isAdded = inner.addAtIndex(index, element);
		inner.sort(comp);
		setOrderingMode(decoratorOrdering);
		return isAdded;
	}
	
	@Override
	protected boolean primitive_resetAtIndex(int index, E element) {
		boolean isReset = inner.resetAtIndex(index, element);
		inner.sort(comp);
		setOrderingMode(decoratorOrdering);
		return isReset;
		
	}
	*/
	
	@Override
	protected void primitive_resetAccessMode(AccessMode accessMode) {
		inner.resetAccessMode(accessMode); 
		inner.sort(comp);
	}

}
	

