package testing;



import minicollection.*;


/**
 * @author Jenny Harlow
 * 
 * Test bags of pairs
 *
 */
public class TestBasicBagPairs {
	
		
	public static void main(String[] args) {
		
		IMiniBagPairs<Author, CharacterType> bag = null;
		
		IFactoryMiniBagPairs<Author, CharacterType> factory = 
			new FactoryMiniBagPairs<Author,CharacterType>();
		
		Author Heyer = new Author("Georgette Heyer");
		Author Simenon = new Author("Simenon");
		Author Pratchett = new Author("Terry Pratchett");
		Author Fleming = new Author("Ian Fleming");
		
		CharacterType StrongAndSilent = new CharacterType("Strong and Silent");
		CharacterType SAndS = new CharacterType("Strong and Silent");
		CharacterType IntelligentHeroine = new CharacterType("Intelligent Heroine");
		CharacterType FluffyBlonde = new CharacterType("Fluffy Blonde");
		CharacterType BitOfStuff = new CharacterType("Fluffy Blonde");
		CharacterType HeavyPoliceman = new CharacterType("Heavy Policeman");
		CharacterType DowntroddenWife = new CharacterType("Downtrodden Wife");
		CharacterType HenpeckedHusband = new CharacterType("Henpecked Husband");
		CharacterType EvilVillain = new CharacterType("Evil Villain");
		CharacterType MaleFriend = new CharacterType("Uncompetitive Male Friend");
		CharacterType Wizard = new CharacterType("Wizard");
		CharacterType Witch = new CharacterType("Witch");
		CharacterType Troll = new CharacterType("Troll");
		CharacterType Death = new CharacterType("Death");
		CharacterType Nemesis = new CharacterType("Death");
		CharacterType Retribution = new CharacterType("Death");
		
		try {
		
			
			
			bag = factory.makeBagPairs();
			
			System.out.println("Made a bag: checking size and configuration");
			System.out.println("getMembershipMode() = " + bag.getMembershipMode());
			System.out.println("IsEmpty() is " + bag.isEmpty());
			System.out.println("Size() is " + bag.size());
			System.out.println();
			
			for (int i = 0; i < 5 ; i++) {	bag.add(Heyer, StrongAndSilent); }
			for (int i = 0; i < 1 ; i++) {	bag.add(Heyer, SAndS); }
			for (int i = 0; i < 3 ; i++) {	bag.add(Heyer, FluffyBlonde); }
			for (int i = 0; i < 6 ; i++) {	bag.add(Heyer, IntelligentHeroine); }
			for (int i = 0; i < 2 ; i++) {	bag.add(Heyer, EvilVillain); }
			for (int i = 0; i < 1 ; i++) {	bag.add(Simenon, HeavyPoliceman); }
			
			for (int i = 0; i < 2 ; i++) {	bag.add(Simenon, DowntroddenWife); }
			for (int i = 0; i < 4 ; i++) {	bag.add(Simenon, HenpeckedHusband); }
			for (int i = 0; i < 3 ; i++) {	bag.add(Simenon, FluffyBlonde); }
			for (int i = 0; i < 3 ; i++) {	bag.add(Simenon, Nemesis); }
			for (int i = 0; i < 10 ; i++) {	bag.add(Pratchett, Wizard); }
			for (int i = 0; i < 4 ; i++) {	bag.add(Pratchett, Witch); }
			for (int i = 0; i < 5 ; i++) {	bag.add(Pratchett, Troll); }
			for (int i = 0; i < 1 ; i++) {	bag.add(Pratchett, Death); }
			for (int i = 0; i < 1 ; i++) {	bag.add(Pratchett, IntelligentHeroine); }
			for (int i = 0; i < 1 ; i++) {	bag.add(Fleming, SAndS); }
			for (int i = 0; i < 1 ; i++) {	bag.add(Fleming, MaleFriend); }
			for (int i = 0; i < 7 ; i++) {	bag.add(Fleming, BitOfStuff); }
			for (int i = 0; i < 1 ; i++) {	bag.add(Fleming, EvilVillain); }
			for (int i = 0; i < 4 ; i++) {	bag.add(Fleming, Retribution); }
			
			
			System.out.println("Added 4 authors, 65 mappings");
			System.out.println("isEmpty() is " + bag.isEmpty());
			System.out.println("size() is " + bag.size());
			System.out.println("uniqueKeySize() is " + bag.uniqueKeySize());
			System.out.println("uniqueKeyValuePairSize() is " + bag.uniqueKeyValuePairSize());
			System.out.println();
			
		}
		catch (Exception e) {
			System.out.println(e.toString());
			
		}
		
		try {
			System.out.println("output contents of bag as a sequence and iterating we get");
			IMiniSequence<IMiniKeyValuePair<IMiniKeyValuePair<Author,CharacterType>,Integer>> seq 
								= bag.getKeyValuePairsAndCounts();
			for (IMiniKeyValuePair<IMiniKeyValuePair<Author,CharacterType>,Integer> p : seq) {
				System.out.println(p); }

			System.out.println();
		}
		catch (Exception e) {
			System.out.println(e.toString());
			
		}
		
		try {	
			System.out.println("iterating bag using for-each gives");
			for (IMiniKeyValuePair<IMiniKeyValuePair<Author, CharacterType>, Integer> pair : bag) {
				System.out.println(pair);
			}
			System.out.println();
			
			System.out.println("iterating bag using bag iterator with currentKey(), currentValue() and currentCount() we can output as");
			IMiniBagPairsIterator<Author, CharacterType> it = bag.bagIterator();
			while(it.current() != null) {
				System.out.println("Author " + it.currentKey() + " uses character "
						+ it.currentValue() + " " + it.currentCount() + " times");
				it.next();
			}
			System.out.println();
		}
		catch (Exception e) {
			System.out.println(e.toString());
			e.printStackTrace();
			
		}
		
		try {	
			System.out.println("iterating through keys using bag.getKeys() gives");
			for (Author author : bag.getKeys()) {System.out.println(author);}
			System.out.println();
			
			System.out.println("iterating through keys and values " +
					"using bag.getKeyValuePairs()");
			for (IMiniKeyValuePair<Author,CharacterType> pair :
						bag.getKeyValuePairs()) {
				System.out.println(pair);
			}
			System.out.println();
		}
		catch (Exception e) {
			System.out.println(e.toString());
			
		}
		System.out.println();
		try {
			Author au = Heyer;
			System.out.println("get a sequence of all the values for key " 
					+ au + " bag.getValues("+ au + "):");
			for (CharacterType ct : bag.getValues(au)) {System.out.println(ct);}
			System.out.println();
			
			System.out.println("get a sequence of all the values and counts for key " 
					+ au + " bag.getValuesAndCounts("+ au + "):");
			for (IMiniKeyValuePair<CharacterType,Integer> ctcount 
					: bag.getValuesAndCounts(au)) {System.out.println(ctcount);}
			System.out.println();
			
			System.out.println("iterating through keys and values in bag " +
					"using bag.getKeyValuePairs()");
			for (IMiniKeyValuePair<Author,CharacterType> pair :
						bag.getKeyValuePairs()) {
				System.out.println(pair);
			}
			System.out.println();
		}
		catch (Exception e) {
			System.out.println(e.toString());
			
		}
		System.out.println();
		try {	
			
			Author au = Heyer;
			System.out.println("check if bag contains " + au);
			boolean contains = bag.contains(au);
			System.out.println("bag.contains(" + au + ") = " + contains);
			int count = bag.count(au);
			System.out.println("count for " + au + " is " + count);
			
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
		System.out.println();
		try {	
			Author au = new Author("Asimonov");
			System.out.println("check if bag contains " + au);
			boolean contains = bag.contains(au);
			System.out.println("bag.contains(" + au + ") = " + contains);
			int count = bag.count(au);
			System.out.println("count for " + au + " is " + count);
			
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
		System.out.println();
		try {	
			Author au = Heyer;
			CharacterType ct = FluffyBlonde;
						System.out.println("check if bag contains " + au + " with " + ct);
			boolean contains = bag.containsPair(au,ct);
			System.out.println("bag.contains(" + au + ", " + ct + ") " 
						+ contains);
			
			System.out.println("count for (" + au + ", " + ct + ") is " 
					+ bag.countPair(au, ct));
			
			ct = Wizard;
			System.out.println("check if bag contains (" + au + ", " + ct +")");
			contains = bag.containsPair(au,ct);
			System.out.println("bag.contains(" + au + ", " + ct + ") " 
						+ contains);
			
			System.out.println("count for (" + au + ", " + ct + ") is " 
					+ bag.countPair(au, ct));
			
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
		System.out.println();
		try {
			
			Author Chrichton = new Author("Crichton");
			CharacterType Cardboard = new CharacterType("Cardboard");
			
			Author au = Chrichton;
			CharacterType ct = Cardboard;
			
			System.out.println("adding author " + au 
					+ " mapped to character " + ct);
			InsertCheck isAdded = bag.add(au, ct);
			System.out.println("result is " + isAdded);
			
			System.out.println("and some more - adding author " + au 
					+ " mapped to character " + ct);
			isAdded = bag.add(au, ct);
			System.out.println("result is " + isAdded);
			
			System.out.println("adding author " + au 
					+ " mapped to character " + ct);
			isAdded = bag.add(au, ct);
			System.out.println("result is " + isAdded);
			
			System.out.println("sequence now is ");
			for (IMiniKeyValuePair<IMiniKeyValuePair<Author, CharacterType>, Integer> pair : bag) {
				System.out.println(pair);
			}
			System.out.println();
			
			ct = FluffyBlonde;
			
			System.out.println("adding author " + au 
					+ " mapped to character " + ct);
			isAdded = bag.add(au, ct);
			System.out.println("result is " + isAdded);
			
			System.out.println("get a sequence of all the values and counts for key " + au);
			for (IMiniKeyValuePair<CharacterType,Integer> ctcount 
					: bag.getValuesAndCounts(au)) {System.out.println(ctcount);}
			System.out.println();
			
			ct = Cardboard;
			System.out.println("removing one mapping of author " + au 
					+ " mapped to character " + ct);
			boolean removedOne = bag.removeOnePair(au, ct);
			System.out.println("removeOnePair(" + au + ", " + ct + ") returned " 
					+ removedOne);
			int count = bag.countPair(au, ct);
			System.out.println("count of remaining (" + au + ", " + ct + ") = " 
					+ count);
			boolean removedAll = bag.removeAllPair(au, ct);
			System.out.println("removeAllPair(" + au + ", " + ct + ") returned " 
					+ removedAll);
			count = bag.countPair(au, ct);
			System.out.println("count of remaining (" + au + ", " + ct + ") = " 
					+ count);
			removedAll = bag.removeAllPair(au, ct);
			System.out.println("repeating removeAllPair(" + au + ", " + ct 
					+ ") returned " + removedAll);
			count = bag.count(au);
			System.out.println();
			System.out.println("still have " + count + " for " + au 
					+ "; bag.getValues(" + au + ") gives");
			IMiniSequence<CharacterType> aucts = bag.getValues(au);
			for (CharacterType auct : aucts) { System.out.println(auct); }
			for (CharacterType auct : aucts) {
				System.out.println("removeOnePair(" + au + ", " + auct +")");
				bag.removeOnePair(au, auct);
			}
			count = bag.count(au);
			boolean contains = bag.contains(au);
			System.out.println("count for " + au + " is " + count 
					+ ", contains(" + au + ") is " + contains);
			
			System.out.println();
			System.out.println("trying removing key " + au);
			boolean removed = bag.removeAll(au);
			System.out.println("remove(" + au +") returned " + removed);
			System.out.println();
			
			System.out.println("iterating over authors using " +
					"(Author author : bag.getKeys()) gives");
			for (Author author : bag.getKeys()) {System.out.println(author);}
			System.out.println();
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
		
		System.out.println();
		IMiniBagPairs<Author,CharacterType> anotherBag = null;
		try {
						
			anotherBag 
				= factory.makeBagPairs(bag);
			
			System.out.println("Made anotherBag to copy this one: checking size and configuration");
			System.out.println("getMembershipMode() = " + anotherBag.getMembershipMode());
			System.out.println("isEmpty() is " + anotherBag.isEmpty());
			System.out.println("size is() " + anotherBag.size());
			System.out.println();
			System.out.print("try removeDuplicates() on anotherBag");
			
			anotherBag.removeDuplicates();
			
			System.out.println(", sequence now is");
			for (IMiniKeyValuePair<IMiniKeyValuePair<Author, CharacterType>, Integer> pair
													: anotherBag) {
				System.out.println("Author " + pair.getFirst().getFirst() +
						" has character " + pair.getFirst().getSecond() + " " 
						+ pair.getSecond() + " times");
			}
			
			System.out.println();
			System.out.print("try removeDuplicateKeys() on anotherBag");
			anotherBag.removeDuplicateKeys();
			
			System.out.println(", sequence now is");
			for (IMiniKeyValuePair<IMiniKeyValuePair<Author, CharacterType>, Integer> pair
													: anotherBag) {
				System.out.println("Author " + pair.getFirst().getFirst() +
						" has character " + pair.getFirst().getSecond() + " " 
						+ pair.getSecond() + " times");
			}
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
		System.out.println();
		
		
		try {
			
			IMiniBagPairsIterator<Author, CharacterType> it = 
				anotherBag.bagIterator();
			System.out.println("try to use iteration on MiniBagIterator " +
					"to remove everything in anotherBag");
			while(it.current() != null) {
				System.out.println("removing " + it.current());
				it.removeCurrent();
				it.next();
			}
			System.out.println("size now is " + anotherBag.size() + ", and isEmpty is " + anotherBag.isEmpty());
			
		}
		catch (Exception e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
		System.out.println();
		
		
		
		try {
			
			System.out.println("Going back to the original bag");
			System.out.println("iterating bag using bag iterator we can get output as");
			IMiniBagPairsIterator<Author, CharacterType> it = bag.bagIterator();
			while(it.current() != null) {
				System.out.println("Author " + it.currentKey() + " uses character "
						+ it.currentValue() + " " + it.currentCount() + " times");
				it.next();
			}
			System.out.println();
			System.out.println("Reversing the mappings using factory.makeReversePairsBag(bag)");
			IMiniBagPairs<CharacterType, Author> reverseBag = 
					factory.makeBagReversePairs(bag);
			System.out.println("for reverseBag:");
			System.out.println("Size is " + reverseBag.size());
			System.out.println("uniqueKeySize is " + reverseBag.uniqueKeySize());
			System.out.println("uniqueKeyValuePairSize is " + reverseBag.uniqueKeyValuePairSize());
			System.out.println();
			
			IMiniBagPairsIterator<CharacterType, Author> rit = reverseBag.bagIterator();
			while(rit.current() != null) {
				System.out.println("CharacterType " + rit.currentKey() + " used by author "
						+ rit.currentValue() + " " + rit.currentCount() + " times");
				rit.next();
			}
			System.out.println();
			
		}
		catch (Exception e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
		try {
			IMiniBasicCollection
					<IMiniKeyValuePair<IMiniKeyValuePair<Author,CharacterType>,Integer>>
					fixedBag
					= factory.makeFixedMembershipCollection(bag);
			System.out.println("Going back to the original bag, making fixed membership copy");
			System.out.println("checking configuration");
			System.out.println("getMembershipMode() = " + fixedBag.getMembershipMode());
			
			System.out.println("Copy contains");
			for (IMiniKeyValuePair<IMiniKeyValuePair<Author,CharacterType>,Integer> pair : fixedBag) {
				System.out.println(pair);
			}
			Author BeatrixPotter = new Author("Beatrix Potter");
			CharacterType bunny = new CharacterType("Bunny");
			Author au = BeatrixPotter;
			CharacterType ct = bunny;
			int count = 10;
			for (int i = 0; i < count; i++)
				bag.add(BeatrixPotter, bunny);
			System.out.println();
			
			System.out.println("Adding new pair (" + au + ", " + ct + ") " 
					+ count + " times to the original bag:");
			System.out.println("iterating bag using bag iterator we can get output as");
			IMiniBagPairsIterator<Author, CharacterType> it = bag.bagIterator();
			while(it.current() != null) {
				System.out.println("Author " + it.currentKey() + " uses character "
						+ it.currentValue() + " " + it.currentCount() + " times");
				it.next();
			}
			System.out.println();
			System.out.println("Now the fixed membership bag contains");
			for (IMiniKeyValuePair<IMiniKeyValuePair<Author,CharacterType>,Integer> pair : fixedBag) {
				System.out.println(pair);
			}
			System.out.println();
			
			System.out.println();
			
		}
		catch (Exception e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
		
			
		System.out.println();
		
	}
	
	private static class Author implements Comparable<Author>{
		String name;
		private Author() {}
		public Author(String name) {this.name = name; }
		public String getName() { return name; }
		public boolean equals(Object o) {
			if (o == this) return true;
			if (o == null) return false;
			if (getClass() != o.getClass()) return false;
			Author that = (Author) o;
			return this.name.equals(that.getName());
		}
		public int hashCode() {
			return name.hashCode();
		}
		public String toString() {return name; }
		public int compareTo(Author that) {
			//int retvalue = 0;
			//if (this.name.length() < that.getName().length()) retvalue = -1;
			//if (this.name.length() < that.getName().length()) retvalue = 1;
			return (this.name.compareTo(that.getName()));
		}
	}
	
	private static class CharacterType {
		String description;
		private CharacterType() {}
		public CharacterType(String description) {this.description = description; }
		public String getDescription() { return description; }
		public boolean equals(Object o) {
			if (o == this) return true;
			if (o == null) return false;
			if (getClass() != o.getClass()) return false;
			CharacterType that = (CharacterType) o;
			return this.description.equals(that.getDescription());
		}
		public int hashCode() {
			return description.hashCode();
		}
		public String toString() {return description; }
		public int compareTo(CharacterType that) {
			return (this.description.compareTo(that.getDescription()));
		}
	}

}
