package testing;

import minicollection.*;

/**
 * @author Jenny Harlow
 * 
 * Test copying a sequence
 *
 */
public class TestCopyBagSingles {
	
	public static void main(String[] args) {
		
		
		IMiniBagSingles<String> bag = null;
		IFactoryMiniBagSingles<String> factory = null;
		
		try {
			factory = new FactoryMiniBagSingles<String>();
			
			bag = factory.makeBagSingles();
			System.out.println("made empty bag");
			
			
			bag.add("Jenny");
			bag.add("Jenny");
			bag.add("Wal");
			bag.add("Wal");
			bag.add("Linda");
			
			System.out.println("added Jenny x 2 , Wal x 2, Linda x 1");
			System.out.println("IsEmpty is " + bag.isEmpty());
			System.out.println("Size is " + bag.size());
		}
		catch (Exception e) {
			
		}
		
		try {
			System.out.println("making anotherBag as a copy of bag");
			
			IMiniBagSingles<String> anotherBag = factory.makeBagSingles(bag);
			
			System.out.println("iterating through anotherBag");
			
			IMiniIterator<IMiniKeyValuePair<String,Integer>> it = 
			anotherBag.miniIterator();
			while(it.current() != null) {
				System.out.print(it.current() + "  ");
				it.next();
			}
			System.out.println();
		}
		catch (Exception e) {
			System.out.println("That resulted in an exception:");
			System.out.println(e.toString());
		}	
		System.out.println();
		
		try {
			
			IFactoryMiniBagSingles<String> uniquesfactory = 
					new FactoryMiniBagSinglesUniqueOnly<String>();
			
			IMiniBagSingles<String> uniquesBag = uniquesfactory.makeBagSingles(bag);
			System.out.println("making uniquesBag as a copy of bag");
			
			System.out.println("iterating through uniquesBag");
			
			IMiniIterator<IMiniKeyValuePair<String,Integer>> it = 
				uniquesBag.miniIterator();
			while(it.current() != null) {
				System.out.print(it.current() + "  ");
				it.next();
			}
			System.out.println();	
		}
		catch (Exception e) {
			System.out.println("That resulted in an exception:");
			System.out.println(e.toString());
		}	
		System.out.println();
		
		try {
			IFactoryMiniSequence<String> seqfactory 
						= new FactoryMiniSequence<String>();
			
			IMiniSequence<String> seq = seqfactory.makeSequence();
			
			seq.add("Jenny");
			seq.add("Wal");
			seq.add("Jenny");
			seq.add("Linda");
			seq.add("Wal");
			
			System.out.println("made a sequence:");
			for (String ss : seq) System.out.println(ss + "  ");
			System.out.println();
			
			IMiniBagSingles<String> seqBag = factory.makeBagSingles(seq);
			System.out.println("making seqBag as a copy of the sequence");
			
			System.out.println("iterating through seqBag");
			
			IMiniIterator<IMiniKeyValuePair<String,Integer>> it = 
				seqBag.miniIterator();
			while(it.current() != null) {
				System.out.print(it.current() + "  ");
				it.next();
			}
			System.out.println();	
		}
		catch (Exception e) {
			System.out.println("That resulted in an exception:");
			System.out.println(e.toString());
		}	
		System.out.println();
		
		try {
			IFactoryMiniSequence<String> seqfactory 
						= new FactoryMiniSequence<String>();
			
			IMiniSequence<String> seq = seqfactory.makeSequence();
			
			seq.add("Jenny");
			seq.add("Wal");
			seq.add("Jenny");
			seq.add("Linda");
			seq.add("Wal");
			
			System.out.println("made a sequence:");
			for (String ss : seq) System.out.println(ss + "  ");
			System.out.println();
			
			IFactoryMiniBagSingles<String> uniquesfactory = 
				new FactoryMiniBagSinglesUniqueOnly<String>();
		
			IMiniBagSingles<String> uniquesSeqBag 
				= uniquesfactory.makeBagSingles(seq);
		
			System.out.println("making uniquesSeqBag as a copy of the sequence");
			
			System.out.println("iterating through uniquesSeqBag");
			
			IMiniIterator<IMiniKeyValuePair<String,Integer>> it = 
				uniquesSeqBag.miniIterator();
			while(it.current() != null) {
				System.out.print(it.current() + "  ");
				it.next();
			}
			System.out.println();	
		}
		catch (Exception e) {
			System.out.println("That resulted in an exception:");
			System.out.println(e.toString());
		}	
		System.out.println();

	}

}
